module tcb_mem_harness();

localparam N_TCP=16;
localparam ADDR_WIDTH = $clog2(N_TCP);
localparam TCB_WIDTH = $bits(tcb_t);

logic clk;
logic rst;

logic [7:0] max_tcb;

logic [ADDR_WIDTH-1:0] r_tcb_addr;
logic r_tcb_valid;
logic r_tcb_ready;
tcb_t r_tcb;

logic [ADDR_WIDTH-1:0] w_tcb_addr;
logic w_tcb_valid;
tcb_t w_tcb;


tcb_mem #(
    .N_TCP(N_TCP)
) u_dut (
    .i_clk          (clk),
    .i_rst          (rst),

    .i_max_tcb      (max_tcb),

    .o_tcb_addr     (r_tcb_addr),
    .o_tcb_valid    (r_tcb_valid),
    .i_tcb_ready    (r_tcb_ready),
    .o_tcb          (r_tcb),

    .i_tcb_addr     (w_tcb_addr),
    .i_tcb_valid    (w_tcb_valid),
    .i_tcb          (w_tcb)
);


endmodule