module tcp_sw_interface_harness();

localparam N_TCP=16;
localparam EVENT_WIDTH=3;
localparam EVENT_DATA_WIDTH=64;
localparam TCP_ADDR_WIDTH=$clog2(N_TCP);

logic                           clk;
logic                           rst;

logic [31:0]                    paddr;
logic                           psel;
logic                           penable;
logic                           pwrite;
logic [31:0]                    pwdata;
logic [3:0]                     pstrb;
logic                           pready;
logic [31:0]                    prdata;
logic                           pslverr;
logic [TCP_ADDR_WIDTH-1:0]      tcp_addr;
logic [EVENT_WIDTH-1:0]         r_event;
logic [EVENT_DATA_WIDTH-1:0]    r_event_data;
logic                           r_event_valid;
logic                           r_event_ready;


tcp_sw_interface #(
    .N_TCP(N_TCP)
) u_dut (
    .i_clk           (clk),
    .i_rst           (rst),

    .i_paddr         (paddr),
    .i_psel          (psel),
    .i_penable       (penable),
    .i_pwrite        (pwrite),
    .i_pwdata        (pwdata),
    .i_pstrb         (pstrb),
    .o_pready        (pready),
    .o_prdata        (prdata),
    .o_pslverr       (pslverr),
    .o_tcp_addr      (tcp_addr),
    .o_event         (r_event),
    .o_event_data    (r_event_data),
    .o_event_valid   (r_event_valid),
    .i_event_ready   (r_event_ready)
);

endmodule