// Generated by PeakRDL-regblock - A free and open-source SystemVerilog generator
//  https://github.com/SystemRDL/PeakRDL-regblock

module tcp_stream_regs (
        input wire clk,
        input wire rst,

        input wire s_cpuif_req,
        input wire s_cpuif_req_is_wr,
        input wire [6:0] s_cpuif_addr,
        input wire [31:0] s_cpuif_wr_data,
        input wire [31:0] s_cpuif_wr_biten,
        output wire s_cpuif_req_stall_wr,
        output wire s_cpuif_req_stall_rd,
        output wire s_cpuif_rd_ack,
        output wire s_cpuif_rd_err,
        output wire [31:0] s_cpuif_rd_data,
        output wire s_cpuif_wr_ack,
        output wire s_cpuif_wr_err,

        input tcp_stream_regs_pkg::tcp_stream_regs__in_t hwif_in,
        output tcp_stream_regs_pkg::tcp_stream_regs__out_t hwif_out
    );

    //--------------------------------------------------------------------------
    // CPU Bus interface logic
    //--------------------------------------------------------------------------
    logic cpuif_req;
    logic cpuif_req_is_wr;
    logic [6:0] cpuif_addr;
    logic [31:0] cpuif_wr_data;
    logic [31:0] cpuif_wr_biten;
    logic cpuif_req_stall_wr;
    logic cpuif_req_stall_rd;

    logic cpuif_rd_ack;
    logic cpuif_rd_err;
    logic [31:0] cpuif_rd_data;

    logic cpuif_wr_ack;
    logic cpuif_wr_err;

    assign cpuif_req = s_cpuif_req;
    assign cpuif_req_is_wr = s_cpuif_req_is_wr;
    assign cpuif_addr = s_cpuif_addr;
    assign cpuif_wr_data = s_cpuif_wr_data;
    assign cpuif_wr_biten = s_cpuif_wr_biten;
    assign s_cpuif_req_stall_wr = cpuif_req_stall_wr;
    assign s_cpuif_req_stall_rd = cpuif_req_stall_rd;
    assign s_cpuif_rd_ack = cpuif_rd_ack;
    assign s_cpuif_rd_err = cpuif_rd_err;
    assign s_cpuif_rd_data = cpuif_rd_data;
    assign s_cpuif_wr_ack = cpuif_wr_ack;
    assign s_cpuif_wr_err = cpuif_wr_err;

    logic cpuif_req_masked;

    // Read & write latencies are balanced. Stalls not required
    assign cpuif_req_stall_rd = '0;
    assign cpuif_req_stall_wr = '0;
    assign cpuif_req_masked = cpuif_req
                            & !(!cpuif_req_is_wr & cpuif_req_stall_rd)
                            & !(cpuif_req_is_wr & cpuif_req_stall_wr);

    //--------------------------------------------------------------------------
    // Address Decode
    //--------------------------------------------------------------------------
    typedef struct {
        struct {
            logic ports;
            logic flags;
        } open;
        struct {
            logic buffer_addr;
            logic byte_count;
            logic flags;
        } send;
        struct {
            logic buffer_addr;
            logic byte_count;
            logic flags;
        } receive;
        struct {
            logic flags;
        } close;
        struct {
            logic desc_addr;
            logic flags;
        } status;
        struct {
            logic flags;
        } abort;
    } decoded_reg_strb_t;
    decoded_reg_strb_t decoded_reg_strb;
    logic decoded_req;
    logic decoded_req_is_wr;
    logic [31:0] decoded_wr_data;
    logic [31:0] decoded_wr_biten;

    always_comb begin
        decoded_reg_strb.open.ports = cpuif_req_masked & (cpuif_addr == 7'h0);
        decoded_reg_strb.open.flags = cpuif_req_masked & (cpuif_addr == 7'h4);
        decoded_reg_strb.send.buffer_addr = cpuif_req_masked & (cpuif_addr == 7'h10);
        decoded_reg_strb.send.byte_count = cpuif_req_masked & (cpuif_addr == 7'h14);
        decoded_reg_strb.send.flags = cpuif_req_masked & (cpuif_addr == 7'h18);
        decoded_reg_strb.receive.buffer_addr = cpuif_req_masked & (cpuif_addr == 7'h20);
        decoded_reg_strb.receive.byte_count = cpuif_req_masked & (cpuif_addr == 7'h24);
        decoded_reg_strb.receive.flags = cpuif_req_masked & (cpuif_addr == 7'h28);
        decoded_reg_strb.close.flags = cpuif_req_masked & (cpuif_addr == 7'h30);
        decoded_reg_strb.status.desc_addr = cpuif_req_masked & (cpuif_addr == 7'h40);
        decoded_reg_strb.status.flags = cpuif_req_masked & (cpuif_addr == 7'h44);
        decoded_reg_strb.abort.flags = cpuif_req_masked & (cpuif_addr == 7'h50);
    end

    // Pass down signals to next stage
    assign decoded_req = cpuif_req_masked;
    assign decoded_req_is_wr = cpuif_req_is_wr;
    assign decoded_wr_data = cpuif_wr_data;
    assign decoded_wr_biten = cpuif_wr_biten;

    //--------------------------------------------------------------------------
    // Field logic
    //--------------------------------------------------------------------------
    typedef struct {
        struct {
            struct {
                struct {
                    logic [15:0] next;
                    logic load_next;
                } local_port;
                struct {
                    logic [15:0] next;
                    logic load_next;
                } remote_port;
            } ports;
            struct {
                struct {
                    logic next;
                    logic load_next;
                } active;
                struct {
                    logic next;
                    logic load_next;
                } valid;
            } flags;
        } open;
        struct {
            struct {
                struct {
                    logic [31:0] next;
                    logic load_next;
                } addr;
            } buffer_addr;
            struct {
                struct {
                    logic [31:0] next;
                    logic load_next;
                } count;
            } byte_count;
            struct {
                struct {
                    logic [15:0] next;
                    logic load_next;
                } urg_ptr;
                struct {
                    logic next;
                    logic load_next;
                } push;
                struct {
                    logic next;
                    logic load_next;
                } urg;
                struct {
                    logic next;
                    logic load_next;
                } ready;
                struct {
                    logic next;
                    logic load_next;
                } valid;
            } flags;
        } send;
        struct {
            struct {
                struct {
                    logic [31:0] next;
                    logic load_next;
                } addr;
            } buffer_addr;
            struct {
                struct {
                    logic [31:0] next;
                    logic load_next;
                } count;
            } byte_count;
            struct {
                struct {
                    logic next;
                    logic load_next;
                } valid;
            } flags;
        } receive;
        struct {
            struct {
                struct {
                    logic next;
                    logic load_next;
                } abort;
                struct {
                    logic next;
                    logic load_next;
                } valid;
            } flags;
        } close;
        struct {
            struct {
                struct {
                    logic [31:0] next;
                    logic load_next;
                } addr;
            } desc_addr;
            struct {
                struct {
                    logic next;
                    logic load_next;
                } valid;
            } flags;
        } status;
        struct {
            struct {
                struct {
                    logic next;
                    logic load_next;
                } valid;
            } flags;
        } abort;
    } field_combo_t;
    field_combo_t field_combo;

    typedef struct {
        struct {
            struct {
                struct {
                    logic [15:0] value;
                } local_port;
                struct {
                    logic [15:0] value;
                } remote_port;
            } ports;
            struct {
                struct {
                    logic value;
                } active;
                struct {
                    logic value;
                } valid;
            } flags;
        } open;
        struct {
            struct {
                struct {
                    logic [31:0] value;
                } addr;
            } buffer_addr;
            struct {
                struct {
                    logic [31:0] value;
                } count;
            } byte_count;
            struct {
                struct {
                    logic [15:0] value;
                } urg_ptr;
                struct {
                    logic value;
                } push;
                struct {
                    logic value;
                } urg;
                struct {
                    logic value;
                } ready;
                struct {
                    logic value;
                } valid;
            } flags;
        } send;
        struct {
            struct {
                struct {
                    logic [31:0] value;
                } addr;
            } buffer_addr;
            struct {
                struct {
                    logic [31:0] value;
                } count;
            } byte_count;
            struct {
                struct {
                    logic value;
                } valid;
            } flags;
        } receive;
        struct {
            struct {
                struct {
                    logic value;
                } abort;
                struct {
                    logic value;
                } valid;
            } flags;
        } close;
        struct {
            struct {
                struct {
                    logic [31:0] value;
                } addr;
            } desc_addr;
            struct {
                struct {
                    logic value;
                } valid;
            } flags;
        } status;
        struct {
            struct {
                struct {
                    logic value;
                } valid;
            } flags;
        } abort;
    } field_storage_t;
    field_storage_t field_storage;

    // Field: tcp_stream_regs.open.ports.local_port
    always_comb begin
        automatic logic [15:0] next_c;
        automatic logic load_next_c;
        next_c = field_storage.open.ports.local_port.value;
        load_next_c = '0;
        if(decoded_reg_strb.open.ports && decoded_req_is_wr) begin // SW write
            next_c = (field_storage.open.ports.local_port.value & ~decoded_wr_biten[15:0]) | (decoded_wr_data[15:0] & decoded_wr_biten[15:0]);
            load_next_c = '1;
        end
        field_combo.open.ports.local_port.next = next_c;
        field_combo.open.ports.local_port.load_next = load_next_c;
    end
    always_ff @(posedge clk) begin
        if(rst) begin
            field_storage.open.ports.local_port.value <= 16'h0;
        end else if(field_combo.open.ports.local_port.load_next) begin
            field_storage.open.ports.local_port.value <= field_combo.open.ports.local_port.next;
        end
    end
    assign hwif_out.open.ports.local_port.value = field_storage.open.ports.local_port.value;
    // Field: tcp_stream_regs.open.ports.remote_port
    always_comb begin
        automatic logic [15:0] next_c;
        automatic logic load_next_c;
        next_c = field_storage.open.ports.remote_port.value;
        load_next_c = '0;
        if(decoded_reg_strb.open.ports && decoded_req_is_wr) begin // SW write
            next_c = (field_storage.open.ports.remote_port.value & ~decoded_wr_biten[31:16]) | (decoded_wr_data[31:16] & decoded_wr_biten[31:16]);
            load_next_c = '1;
        end
        field_combo.open.ports.remote_port.next = next_c;
        field_combo.open.ports.remote_port.load_next = load_next_c;
    end
    always_ff @(posedge clk) begin
        if(rst) begin
            field_storage.open.ports.remote_port.value <= 16'h0;
        end else if(field_combo.open.ports.remote_port.load_next) begin
            field_storage.open.ports.remote_port.value <= field_combo.open.ports.remote_port.next;
        end
    end
    assign hwif_out.open.ports.remote_port.value = field_storage.open.ports.remote_port.value;
    // Field: tcp_stream_regs.open.flags.active
    always_comb begin
        automatic logic [0:0] next_c;
        automatic logic load_next_c;
        next_c = field_storage.open.flags.active.value;
        load_next_c = '0;
        if(decoded_reg_strb.open.flags && decoded_req_is_wr) begin // SW write
            next_c = (field_storage.open.flags.active.value & ~decoded_wr_biten[0:0]) | (decoded_wr_data[0:0] & decoded_wr_biten[0:0]);
            load_next_c = '1;
        end
        field_combo.open.flags.active.next = next_c;
        field_combo.open.flags.active.load_next = load_next_c;
    end
    always_ff @(posedge clk) begin
        if(rst) begin
            field_storage.open.flags.active.value <= 1'h0;
        end else if(field_combo.open.flags.active.load_next) begin
            field_storage.open.flags.active.value <= field_combo.open.flags.active.next;
        end
    end
    assign hwif_out.open.flags.active.value = field_storage.open.flags.active.value;
    // Field: tcp_stream_regs.open.flags.valid
    always_comb begin
        automatic logic [0:0] next_c;
        automatic logic load_next_c;
        next_c = field_storage.open.flags.valid.value;
        load_next_c = '0;
        if(decoded_reg_strb.open.flags && decoded_req_is_wr) begin // SW write
            next_c = (field_storage.open.flags.valid.value & ~decoded_wr_biten[31:31]) | (decoded_wr_data[31:31] & decoded_wr_biten[31:31]);
            load_next_c = '1;
        end else if(hwif_in.open.flags.valid.hwclr) begin // HW Clear
            next_c = '0;
            load_next_c = '1;
        end
        field_combo.open.flags.valid.next = next_c;
        field_combo.open.flags.valid.load_next = load_next_c;
    end
    always_ff @(posedge clk) begin
        if(rst) begin
            field_storage.open.flags.valid.value <= 1'h0;
        end else if(field_combo.open.flags.valid.load_next) begin
            field_storage.open.flags.valid.value <= field_combo.open.flags.valid.next;
        end
    end
    assign hwif_out.open.flags.valid.value = field_storage.open.flags.valid.value;
    // Field: tcp_stream_regs.send.buffer_addr.addr
    always_comb begin
        automatic logic [31:0] next_c;
        automatic logic load_next_c;
        next_c = field_storage.send.buffer_addr.addr.value;
        load_next_c = '0;
        if(decoded_reg_strb.send.buffer_addr && decoded_req_is_wr) begin // SW write
            next_c = (field_storage.send.buffer_addr.addr.value & ~decoded_wr_biten[31:0]) | (decoded_wr_data[31:0] & decoded_wr_biten[31:0]);
            load_next_c = '1;
        end
        field_combo.send.buffer_addr.addr.next = next_c;
        field_combo.send.buffer_addr.addr.load_next = load_next_c;
    end
    always_ff @(posedge clk) begin
        if(rst) begin
            field_storage.send.buffer_addr.addr.value <= 32'h0;
        end else if(field_combo.send.buffer_addr.addr.load_next) begin
            field_storage.send.buffer_addr.addr.value <= field_combo.send.buffer_addr.addr.next;
        end
    end
    assign hwif_out.send.buffer_addr.addr.value = field_storage.send.buffer_addr.addr.value;
    // Field: tcp_stream_regs.send.byte_count.count
    always_comb begin
        automatic logic [31:0] next_c;
        automatic logic load_next_c;
        next_c = field_storage.send.byte_count.count.value;
        load_next_c = '0;
        if(decoded_reg_strb.send.byte_count && decoded_req_is_wr) begin // SW write
            next_c = (field_storage.send.byte_count.count.value & ~decoded_wr_biten[31:0]) | (decoded_wr_data[31:0] & decoded_wr_biten[31:0]);
            load_next_c = '1;
        end
        field_combo.send.byte_count.count.next = next_c;
        field_combo.send.byte_count.count.load_next = load_next_c;
    end
    always_ff @(posedge clk) begin
        if(rst) begin
            field_storage.send.byte_count.count.value <= 32'h0;
        end else if(field_combo.send.byte_count.count.load_next) begin
            field_storage.send.byte_count.count.value <= field_combo.send.byte_count.count.next;
        end
    end
    assign hwif_out.send.byte_count.count.value = field_storage.send.byte_count.count.value;
    // Field: tcp_stream_regs.send.flags.urg_ptr
    always_comb begin
        automatic logic [15:0] next_c;
        automatic logic load_next_c;
        next_c = field_storage.send.flags.urg_ptr.value;
        load_next_c = '0;
        if(decoded_reg_strb.send.flags && decoded_req_is_wr) begin // SW write
            next_c = (field_storage.send.flags.urg_ptr.value & ~decoded_wr_biten[15:0]) | (decoded_wr_data[15:0] & decoded_wr_biten[15:0]);
            load_next_c = '1;
        end
        field_combo.send.flags.urg_ptr.next = next_c;
        field_combo.send.flags.urg_ptr.load_next = load_next_c;
    end
    always_ff @(posedge clk) begin
        if(rst) begin
            field_storage.send.flags.urg_ptr.value <= 16'h0;
        end else if(field_combo.send.flags.urg_ptr.load_next) begin
            field_storage.send.flags.urg_ptr.value <= field_combo.send.flags.urg_ptr.next;
        end
    end
    assign hwif_out.send.flags.urg_ptr.value = field_storage.send.flags.urg_ptr.value;
    // Field: tcp_stream_regs.send.flags.push
    always_comb begin
        automatic logic [0:0] next_c;
        automatic logic load_next_c;
        next_c = field_storage.send.flags.push.value;
        load_next_c = '0;
        if(decoded_reg_strb.send.flags && decoded_req_is_wr) begin // SW write
            next_c = (field_storage.send.flags.push.value & ~decoded_wr_biten[16:16]) | (decoded_wr_data[16:16] & decoded_wr_biten[16:16]);
            load_next_c = '1;
        end
        field_combo.send.flags.push.next = next_c;
        field_combo.send.flags.push.load_next = load_next_c;
    end
    always_ff @(posedge clk) begin
        if(rst) begin
            field_storage.send.flags.push.value <= 1'h0;
        end else if(field_combo.send.flags.push.load_next) begin
            field_storage.send.flags.push.value <= field_combo.send.flags.push.next;
        end
    end
    assign hwif_out.send.flags.push.value = field_storage.send.flags.push.value;
    // Field: tcp_stream_regs.send.flags.urg
    always_comb begin
        automatic logic [0:0] next_c;
        automatic logic load_next_c;
        next_c = field_storage.send.flags.urg.value;
        load_next_c = '0;
        if(decoded_reg_strb.send.flags && decoded_req_is_wr) begin // SW write
            next_c = (field_storage.send.flags.urg.value & ~decoded_wr_biten[17:17]) | (decoded_wr_data[17:17] & decoded_wr_biten[17:17]);
            load_next_c = '1;
        end
        field_combo.send.flags.urg.next = next_c;
        field_combo.send.flags.urg.load_next = load_next_c;
    end
    always_ff @(posedge clk) begin
        if(rst) begin
            field_storage.send.flags.urg.value <= 1'h0;
        end else if(field_combo.send.flags.urg.load_next) begin
            field_storage.send.flags.urg.value <= field_combo.send.flags.urg.next;
        end
    end
    assign hwif_out.send.flags.urg.value = field_storage.send.flags.urg.value;
    // Field: tcp_stream_regs.send.flags.ready
    always_comb begin
        automatic logic [0:0] next_c;
        automatic logic load_next_c;
        next_c = field_storage.send.flags.ready.value;
        load_next_c = '0;
        if(hwif_in.send.flags.ready.hwclr) begin // HW Clear
            next_c = '0;
            load_next_c = '1;
        end else begin // HW Write
            next_c = hwif_in.send.flags.ready.next;
            load_next_c = '1;
        end
        field_combo.send.flags.ready.next = next_c;
        field_combo.send.flags.ready.load_next = load_next_c;
    end
    always_ff @(posedge clk) begin
        if(rst) begin
            field_storage.send.flags.ready.value <= 1'h0;
        end else if(field_combo.send.flags.ready.load_next) begin
            field_storage.send.flags.ready.value <= field_combo.send.flags.ready.next;
        end
    end
    // Field: tcp_stream_regs.send.flags.valid
    always_comb begin
        automatic logic [0:0] next_c;
        automatic logic load_next_c;
        next_c = field_storage.send.flags.valid.value;
        load_next_c = '0;
        if(decoded_reg_strb.send.flags && decoded_req_is_wr) begin // SW write
            next_c = (field_storage.send.flags.valid.value & ~decoded_wr_biten[31:31]) | (decoded_wr_data[31:31] & decoded_wr_biten[31:31]);
            load_next_c = '1;
        end
        field_combo.send.flags.valid.next = next_c;
        field_combo.send.flags.valid.load_next = load_next_c;
    end
    always_ff @(posedge clk) begin
        if(rst) begin
            field_storage.send.flags.valid.value <= 1'h0;
        end else if(field_combo.send.flags.valid.load_next) begin
            field_storage.send.flags.valid.value <= field_combo.send.flags.valid.next;
        end
    end
    assign hwif_out.send.flags.valid.value = field_storage.send.flags.valid.value;
    // Field: tcp_stream_regs.receive.buffer_addr.addr
    always_comb begin
        automatic logic [31:0] next_c;
        automatic logic load_next_c;
        next_c = field_storage.receive.buffer_addr.addr.value;
        load_next_c = '0;
        if(decoded_reg_strb.receive.buffer_addr && decoded_req_is_wr) begin // SW write
            next_c = (field_storage.receive.buffer_addr.addr.value & ~decoded_wr_biten[31:0]) | (decoded_wr_data[31:0] & decoded_wr_biten[31:0]);
            load_next_c = '1;
        end
        field_combo.receive.buffer_addr.addr.next = next_c;
        field_combo.receive.buffer_addr.addr.load_next = load_next_c;
    end
    always_ff @(posedge clk) begin
        if(rst) begin
            field_storage.receive.buffer_addr.addr.value <= 32'h0;
        end else if(field_combo.receive.buffer_addr.addr.load_next) begin
            field_storage.receive.buffer_addr.addr.value <= field_combo.receive.buffer_addr.addr.next;
        end
    end
    assign hwif_out.receive.buffer_addr.addr.value = field_storage.receive.buffer_addr.addr.value;
    // Field: tcp_stream_regs.receive.byte_count.count
    always_comb begin
        automatic logic [31:0] next_c;
        automatic logic load_next_c;
        next_c = field_storage.receive.byte_count.count.value;
        load_next_c = '0;
        if(decoded_reg_strb.receive.byte_count && decoded_req_is_wr) begin // SW write
            next_c = (field_storage.receive.byte_count.count.value & ~decoded_wr_biten[31:0]) | (decoded_wr_data[31:0] & decoded_wr_biten[31:0]);
            load_next_c = '1;
        end
        field_combo.receive.byte_count.count.next = next_c;
        field_combo.receive.byte_count.count.load_next = load_next_c;
    end
    always_ff @(posedge clk) begin
        if(rst) begin
            field_storage.receive.byte_count.count.value <= 32'h0;
        end else if(field_combo.receive.byte_count.count.load_next) begin
            field_storage.receive.byte_count.count.value <= field_combo.receive.byte_count.count.next;
        end
    end
    assign hwif_out.receive.byte_count.count.value = field_storage.receive.byte_count.count.value;
    // Field: tcp_stream_regs.receive.flags.valid
    always_comb begin
        automatic logic [0:0] next_c;
        automatic logic load_next_c;
        next_c = field_storage.receive.flags.valid.value;
        load_next_c = '0;
        if(decoded_reg_strb.receive.flags && decoded_req_is_wr) begin // SW write
            next_c = (field_storage.receive.flags.valid.value & ~decoded_wr_biten[31:31]) | (decoded_wr_data[31:31] & decoded_wr_biten[31:31]);
            load_next_c = '1;
        end else if(hwif_in.receive.flags.valid.hwclr) begin // HW Clear
            next_c = '0;
            load_next_c = '1;
        end
        field_combo.receive.flags.valid.next = next_c;
        field_combo.receive.flags.valid.load_next = load_next_c;
    end
    always_ff @(posedge clk) begin
        if(rst) begin
            field_storage.receive.flags.valid.value <= 1'h0;
        end else if(field_combo.receive.flags.valid.load_next) begin
            field_storage.receive.flags.valid.value <= field_combo.receive.flags.valid.next;
        end
    end
    assign hwif_out.receive.flags.valid.value = field_storage.receive.flags.valid.value;
    // Field: tcp_stream_regs.close.flags.abort
    always_comb begin
        automatic logic [0:0] next_c;
        automatic logic load_next_c;
        next_c = field_storage.close.flags.abort.value;
        load_next_c = '0;
        if(decoded_reg_strb.close.flags && decoded_req_is_wr) begin // SW write
            next_c = (field_storage.close.flags.abort.value & ~decoded_wr_biten[0:0]) | (decoded_wr_data[0:0] & decoded_wr_biten[0:0]);
            load_next_c = '1;
        end
        field_combo.close.flags.abort.next = next_c;
        field_combo.close.flags.abort.load_next = load_next_c;
    end
    always_ff @(posedge clk) begin
        if(rst) begin
            field_storage.close.flags.abort.value <= 1'h0;
        end else if(field_combo.close.flags.abort.load_next) begin
            field_storage.close.flags.abort.value <= field_combo.close.flags.abort.next;
        end
    end
    assign hwif_out.close.flags.abort.value = field_storage.close.flags.abort.value;
    // Field: tcp_stream_regs.close.flags.valid
    always_comb begin
        automatic logic [0:0] next_c;
        automatic logic load_next_c;
        next_c = field_storage.close.flags.valid.value;
        load_next_c = '0;
        if(decoded_reg_strb.close.flags && decoded_req_is_wr) begin // SW write
            next_c = (field_storage.close.flags.valid.value & ~decoded_wr_biten[31:31]) | (decoded_wr_data[31:31] & decoded_wr_biten[31:31]);
            load_next_c = '1;
        end else if(hwif_in.close.flags.valid.hwclr) begin // HW Clear
            next_c = '0;
            load_next_c = '1;
        end
        field_combo.close.flags.valid.next = next_c;
        field_combo.close.flags.valid.load_next = load_next_c;
    end
    always_ff @(posedge clk) begin
        if(rst) begin
            field_storage.close.flags.valid.value <= 1'h0;
        end else if(field_combo.close.flags.valid.load_next) begin
            field_storage.close.flags.valid.value <= field_combo.close.flags.valid.next;
        end
    end
    assign hwif_out.close.flags.valid.value = field_storage.close.flags.valid.value;
    // Field: tcp_stream_regs.status.desc_addr.addr
    always_comb begin
        automatic logic [31:0] next_c;
        automatic logic load_next_c;
        next_c = field_storage.status.desc_addr.addr.value;
        load_next_c = '0;
        if(decoded_reg_strb.status.desc_addr && decoded_req_is_wr) begin // SW write
            next_c = (field_storage.status.desc_addr.addr.value & ~decoded_wr_biten[31:0]) | (decoded_wr_data[31:0] & decoded_wr_biten[31:0]);
            load_next_c = '1;
        end
        field_combo.status.desc_addr.addr.next = next_c;
        field_combo.status.desc_addr.addr.load_next = load_next_c;
    end
    always_ff @(posedge clk) begin
        if(rst) begin
            field_storage.status.desc_addr.addr.value <= 32'h0;
        end else if(field_combo.status.desc_addr.addr.load_next) begin
            field_storage.status.desc_addr.addr.value <= field_combo.status.desc_addr.addr.next;
        end
    end
    assign hwif_out.status.desc_addr.addr.value = field_storage.status.desc_addr.addr.value;
    // Field: tcp_stream_regs.status.flags.valid
    always_comb begin
        automatic logic [0:0] next_c;
        automatic logic load_next_c;
        next_c = field_storage.status.flags.valid.value;
        load_next_c = '0;
        if(decoded_reg_strb.status.flags && decoded_req_is_wr) begin // SW write
            next_c = (field_storage.status.flags.valid.value & ~decoded_wr_biten[31:31]) | (decoded_wr_data[31:31] & decoded_wr_biten[31:31]);
            load_next_c = '1;
        end else if(hwif_in.status.flags.valid.hwclr) begin // HW Clear
            next_c = '0;
            load_next_c = '1;
        end
        field_combo.status.flags.valid.next = next_c;
        field_combo.status.flags.valid.load_next = load_next_c;
    end
    always_ff @(posedge clk) begin
        if(rst) begin
            field_storage.status.flags.valid.value <= 1'h0;
        end else if(field_combo.status.flags.valid.load_next) begin
            field_storage.status.flags.valid.value <= field_combo.status.flags.valid.next;
        end
    end
    assign hwif_out.status.flags.valid.value = field_storage.status.flags.valid.value;
    // Field: tcp_stream_regs.abort.flags.valid
    always_comb begin
        automatic logic [0:0] next_c;
        automatic logic load_next_c;
        next_c = field_storage.abort.flags.valid.value;
        load_next_c = '0;
        if(decoded_reg_strb.abort.flags && decoded_req_is_wr) begin // SW write
            next_c = (field_storage.abort.flags.valid.value & ~decoded_wr_biten[31:31]) | (decoded_wr_data[31:31] & decoded_wr_biten[31:31]);
            load_next_c = '1;
        end else if(hwif_in.abort.flags.valid.hwclr) begin // HW Clear
            next_c = '0;
            load_next_c = '1;
        end
        field_combo.abort.flags.valid.next = next_c;
        field_combo.abort.flags.valid.load_next = load_next_c;
    end
    always_ff @(posedge clk) begin
        if(rst) begin
            field_storage.abort.flags.valid.value <= 1'h0;
        end else if(field_combo.abort.flags.valid.load_next) begin
            field_storage.abort.flags.valid.value <= field_combo.abort.flags.valid.next;
        end
    end
    assign hwif_out.abort.flags.valid.value = field_storage.abort.flags.valid.value;

    //--------------------------------------------------------------------------
    // Write response
    //--------------------------------------------------------------------------
    assign cpuif_wr_ack = decoded_req & decoded_req_is_wr;
    // Writes are always granted with no error response
    assign cpuif_wr_err = '0;

    //--------------------------------------------------------------------------
    // Readback
    //--------------------------------------------------------------------------

    logic readback_err;
    logic readback_done;
    logic [31:0] readback_data;

    // Assign readback values to a flattened array
    logic [31:0] readback_array[7];
    assign readback_array[0][29:0] = '0;
    assign readback_array[0][30:30] = (decoded_reg_strb.open.flags && !decoded_req_is_wr) ? hwif_in.open.flags.ready.next : '0;
    assign readback_array[0][31:31] = '0;
    assign readback_array[1][29:0] = '0;
    assign readback_array[1][30:30] = (decoded_reg_strb.send.flags && !decoded_req_is_wr) ? field_storage.send.flags.ready.value : '0;
    assign readback_array[1][31:31] = '0;
    assign readback_array[2][29:0] = '0;
    assign readback_array[2][30:30] = (decoded_reg_strb.receive.flags && !decoded_req_is_wr) ? hwif_in.receive.flags.ready.next : '0;
    assign readback_array[2][31:31] = '0;
    assign readback_array[3][29:0] = '0;
    assign readback_array[3][30:30] = (decoded_reg_strb.close.flags && !decoded_req_is_wr) ? hwif_in.close.flags.ready.next : '0;
    assign readback_array[3][31:31] = '0;
    assign readback_array[4][31:0] = (decoded_reg_strb.status.desc_addr && !decoded_req_is_wr) ? field_storage.status.desc_addr.addr.value : '0;
    assign readback_array[5][29:0] = '0;
    assign readback_array[5][30:30] = (decoded_reg_strb.status.flags && !decoded_req_is_wr) ? hwif_in.status.flags.ready.next : '0;
    assign readback_array[5][31:31] = '0;
    assign readback_array[6][29:0] = '0;
    assign readback_array[6][30:30] = (decoded_reg_strb.abort.flags && !decoded_req_is_wr) ? hwif_in.abort.flags.ready.next : '0;
    assign readback_array[6][31:31] = '0;

    // Reduce the array
    always_comb begin
        automatic logic [31:0] readback_data_var;
        readback_done = decoded_req & ~decoded_req_is_wr;
        readback_err = '0;
        readback_data_var = '0;
        for(int i=0; i<7; i++) readback_data_var |= readback_array[i];
        readback_data = readback_data_var;
    end

    assign cpuif_rd_ack = readback_done;
    assign cpuif_rd_data = readback_data;
    assign cpuif_rd_err = readback_err;
endmodule
